using System;
using System.Windows.Forms;

namespace RFSExplorer {
	/// <summary>
	/// Summary description for DragDropFile.
	/// </summary>
	public class DragDropFile : IDataObject {
		private string[] fileNames;
		public DragDropFile(string[] fileNames) {
			this.fileNames = fileNames;
		}

		#region IDataObject Members
		public bool GetDataPresent(Type format) {
			return (format.ToString() == DataFormats.FileDrop && fileNames != null && fileNames.Length > 0);
		}

		bool System.Windows.Forms.IDataObject.GetDataPresent(string format) {
			return (format == DataFormats.FileDrop && fileNames != null && fileNames.Length > 0);
		}

		bool System.Windows.Forms.IDataObject.GetDataPresent(string format, bool autoConvert) {
			return (format == DataFormats.FileDrop && fileNames != null && fileNames.Length > 0);
		}

		public object GetData(Type format) {
			if (format.ToString() != DataFormats.FileDrop) { return null; }
			return fileNames;
		}

		object System.Windows.Forms.IDataObject.GetData(string format) {
			if (format != DataFormats.FileDrop) { return null; }
			return fileNames;
		}

		object System.Windows.Forms.IDataObject.GetData(string format, bool autoConvert) {
			if (format != DataFormats.FileDrop) { return null; }
			return fileNames;
		}

		public string[] GetFormats() {
			return new string[] {DataFormats.FileDrop};
		}

		string[] System.Windows.Forms.IDataObject.GetFormats(bool autoConvert) {
			return new string[] {DataFormats.FileDrop};
		}

		public void SetData(object data) {
			throw new System.Exception("Method not supported.");
		}

		void System.Windows.Forms.IDataObject.SetData(Type format, object data) {
			throw new System.Exception("Method not supported.");
		}

		void System.Windows.Forms.IDataObject.SetData(string format, object data) {
			throw new System.Exception("Method not supported.");
		}

		void System.Windows.Forms.IDataObject.SetData(string format, bool autoConvert, object data) {
			throw new System.Exception("Method not supported.");
		}
		#endregion
	}
}
