using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.Threading;
using System.Diagnostics;
using System.IO;

namespace RFSExplorer {
	/// <summary>
	/// Summary description for frmCopy.
	/// </summary>
	public class frmCopy : System.Windows.Forms.Form {
		private Settings settings = null;
		public ArrayList ObjectsToCopy;
		private string[] tempFiles;
		private Thread workerThread = null;
		private DateTime startInstance;

		#region Control Declaration
		private System.Windows.Forms.ListView lvwMain;
		private System.Windows.Forms.ColumnHeader colFileName;
		private System.Windows.Forms.ColumnHeader colProgress;
		private System.Windows.Forms.Label lblHeading;
		private System.Windows.Forms.Button cmdCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private System.Windows.Forms.ProgressBar pgbTotal;
		private System.Windows.Forms.Panel pnlFinished;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button cmdDrag;
		private System.Windows.Forms.Label lblTotalProgress;
		private System.Windows.Forms.Button cmdHideFinishedPanel;
		private System.Windows.Forms.Button cmdCloseAndDeleteFiles;
		#endregion

		public frmCopy(ArrayList objectsToCopy) {
			this.ObjectsToCopy = objectsToCopy;
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if(components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.lvwMain = new System.Windows.Forms.ListView();
			this.colFileName = new System.Windows.Forms.ColumnHeader();
			this.colProgress = new System.Windows.Forms.ColumnHeader();
			this.lblHeading = new System.Windows.Forms.Label();
			this.cmdCancel = new System.Windows.Forms.Button();
			this.pgbTotal = new System.Windows.Forms.ProgressBar();
			this.pnlFinished = new System.Windows.Forms.Panel();
			this.label1 = new System.Windows.Forms.Label();
			this.cmdDrag = new System.Windows.Forms.Button();
			this.cmdCloseAndDeleteFiles = new System.Windows.Forms.Button();
			this.lblTotalProgress = new System.Windows.Forms.Label();
			this.cmdHideFinishedPanel = new System.Windows.Forms.Button();
			this.pnlFinished.SuspendLayout();
			this.SuspendLayout();
			// 
			// lvwMain
			// 
			this.lvwMain.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvwMain.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					  this.colFileName,
																					  this.colProgress});
			this.lvwMain.Location = new System.Drawing.Point(8, 64);
			this.lvwMain.Name = "lvwMain";
			this.lvwMain.Size = new System.Drawing.Size(584, 392);
			this.lvwMain.TabIndex = 0;
			this.lvwMain.View = System.Windows.Forms.View.Details;
			// 
			// colFileName
			// 
			this.colFileName.Text = "File / Directory";
			this.colFileName.Width = 295;
			// 
			// colProgress
			// 
			this.colProgress.Text = "Progress";
			this.colProgress.Width = 73;
			// 
			// lblHeading
			// 
			this.lblHeading.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this.lblHeading.AutoSize = true;
			this.lblHeading.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblHeading.Location = new System.Drawing.Point(230, 8);
			this.lblHeading.Name = "lblHeading";
			this.lblHeading.Size = new System.Drawing.Size(141, 25);
			this.lblHeading.TabIndex = 1;
			this.lblHeading.Text = "Copy Progress";
			// 
			// cmdCancel
			// 
			this.cmdCancel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.cmdCancel.Location = new System.Drawing.Point(8, 465);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(584, 23);
			this.cmdCancel.TabIndex = 2;
			this.cmdCancel.Text = "&Cancel";
			this.cmdCancel.Click += new System.EventHandler(this.cmdCancel_Click);
			// 
			// pgbTotal
			// 
			this.pgbTotal.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pgbTotal.Location = new System.Drawing.Point(96, 36);
			this.pgbTotal.Name = "pgbTotal";
			this.pgbTotal.Size = new System.Drawing.Size(496, 24);
			this.pgbTotal.TabIndex = 3;
			this.pgbTotal.Value = 40;
			// 
			// pnlFinished
			// 
			this.pnlFinished.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlFinished.Controls.Add(this.label1);
			this.pnlFinished.Controls.Add(this.cmdDrag);
			this.pnlFinished.Controls.Add(this.cmdCloseAndDeleteFiles);
			this.pnlFinished.Location = new System.Drawing.Point(112, 168);
			this.pnlFinished.Name = "pnlFinished";
			this.pnlFinished.Size = new System.Drawing.Size(408, 232);
			this.pnlFinished.TabIndex = 4;
			this.pnlFinished.Visible = false;
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(376, 48);
			this.label1.TabIndex = 1;
			this.label1.Text = "Finished creating temporary files. Please drag the button below to the target.";
			// 
			// cmdDrag
			// 
			this.cmdDrag.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cmdDrag.Location = new System.Drawing.Point(16, 80);
			this.cmdDrag.Name = "cmdDrag";
			this.cmdDrag.Size = new System.Drawing.Size(376, 96);
			this.cmdDrag.TabIndex = 0;
			this.cmdDrag.Text = "Drag Me";
			this.cmdDrag.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdDrag_MouseDown);
			// 
			// cmdCloseAndDeleteFiles
			// 
			this.cmdCloseAndDeleteFiles.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cmdCloseAndDeleteFiles.Location = new System.Drawing.Point(16, 200);
			this.cmdCloseAndDeleteFiles.Name = "cmdCloseAndDeleteFiles";
			this.cmdCloseAndDeleteFiles.Size = new System.Drawing.Size(376, 24);
			this.cmdCloseAndDeleteFiles.TabIndex = 0;
			this.cmdCloseAndDeleteFiles.Text = "&Close";
			this.cmdCloseAndDeleteFiles.Click += new System.EventHandler(this.cmdCloseAndDeleteFiles_Click);
			// 
			// lblTotalProgress
			// 
			this.lblTotalProgress.AutoSize = true;
			this.lblTotalProgress.Location = new System.Drawing.Point(8, 40);
			this.lblTotalProgress.Name = "lblTotalProgress";
			this.lblTotalProgress.Size = new System.Drawing.Size(78, 16);
			this.lblTotalProgress.TabIndex = 5;
			this.lblTotalProgress.Text = "Total Progress";
			// 
			// cmdHideFinishedPanel
			// 
			this.cmdHideFinishedPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.cmdHideFinishedPanel.Location = new System.Drawing.Point(512, 8);
			this.cmdHideFinishedPanel.Name = "cmdHideFinishedPanel";
			this.cmdHideFinishedPanel.Size = new System.Drawing.Size(72, 24);
			this.cmdHideFinishedPanel.TabIndex = 0;
			this.cmdHideFinishedPanel.Text = "&Hide";
			this.cmdHideFinishedPanel.Visible = false;
			this.cmdHideFinishedPanel.Click += new System.EventHandler(this.cmdHideFinishedPanel_Click);
			// 
			// frmCopy
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 500);
			this.Controls.Add(this.pnlFinished);
			this.Controls.Add(this.lblTotalProgress);
			this.Controls.Add(this.pgbTotal);
			this.Controls.Add(this.cmdCancel);
			this.Controls.Add(this.lblHeading);
			this.Controls.Add(this.lvwMain);
			this.Controls.Add(this.cmdHideFinishedPanel);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(400, 300);
			this.Name = "frmCopy";
			this.Text = "Copy";
			this.Resize += new System.EventHandler(this.frmCopy_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmCopy_Closing);
			this.Load += new System.EventHandler(this.frmCopy_Load);
			this.pnlFinished.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void frmCopy_Resize(object sender, System.EventArgs e) {
			colFileName.Width = lvwMain.Width - colProgress.Width - 5;
		}

		private void cmdCancel_Click(object sender, System.EventArgs e) {
			if (cmdCancel.Text == "&Cancel") {
				workerThread.Abort();
				cmdCancel.Text = "Cancelling copy process, please wait...";
				cmdCancel.Enabled = false;
			} else {
				DeleteTempFiles();
				this.Close();
			}
		}

		private void frmCopy_Load(object sender, System.EventArgs e) {
			startInstance = DateTime.Now;
			settings = Settings.GetInstance();
			pgbTotal.Value = 0;
			foreach (RFSObject o in ObjectsToCopy) {
				ListViewItem lvwItem = lvwMain.Items.Add(o.AbsolutePath);
				lvwItem.SubItems.Add("Waiting...");
			}

			ThreadStart ts = new ThreadStart(this.StartCopy);
			workerThread = new Thread(ts);
			workerThread.Start();
		}

		/// <summary>
		/// This starts the copying process. Make sure that ObjectsToCopy is populated.
		/// </summary>
		private void StartCopy() {
			if (ObjectsToCopy == null || ObjectsToCopy.Count == 0) {
				throw new Exception("frmCopy.ObjectsToCopy is null or doesn't have any items assigned.");
			}

			Process p = null;
			int itemIndex = 0;
			try {
				int progressChange = 100 / ObjectsToCopy.Count;
				tempFiles = new string[ObjectsToCopy.Count];
				int progressVal = 0;
				for (itemIndex = 0; itemIndex < ObjectsToCopy.Count; itemIndex++) {
					RFSObject o = (RFSObject)ObjectsToCopy[itemIndex];
					string target = (settings.TemporaryDirectory + "\\" + o.Name);
					tempFiles[itemIndex] = target;
					UpdateListItemStatus(itemIndex, "rfstool is copying...");

					p = new Process();
					p.StartInfo = settings.GetRFSToolStartInfo();
					p.StartInfo.Arguments = string.Format(" cp -p{0} \"{1}\"", o.Descriptor, target);
					p.Start();
					while(p.WaitForExit(500) == false) {}
					UpdateListItemStatus(itemIndex, "Finished");
					progressVal += progressChange;
					UpdateProgress(progressVal);
				}
				UpdateProgress(100);

				FinishedCreatingTempFiles();
			} catch (ThreadAbortException) {
				if (p != null) {
					UpdateListItemStatus(itemIndex, "Process cancelled!");
					p.Kill();
				}
				WorkerThreadExited();
			}
		}

		private delegate void UpdateProgressDelegate(int percentDone);
		private delegate void UpdateListItemStatusDelegate(int itemIndex, string newStatus);
		private delegate void VoidFunctionWithNoArgsDelegate();

		private void WorkerThreadExited() {
			if (InvokeRequired) {
				BeginInvoke(new VoidFunctionWithNoArgsDelegate(this.WorkerThreadExited));
			} else {
				cmdCancel.Enabled = true;
				cmdCancel.Text = "Close";
			}
		}

		private void FinishedCreatingTempFiles() {
			if (InvokeRequired) {
				BeginInvoke(new VoidFunctionWithNoArgsDelegate(this.FinishedCreatingTempFiles));
			} else {
				// Thought this was a good idea but it gets confusing so commenting for now.
//				TimeSpan ts = new TimeSpan(TimeSpan.TicksPerSecond * 3);
//				if (DateTime.Now.Subtract(startInstance).CompareTo(ts) <= 0) {
//					this.Hide();
//					InitiateDragDrop();
//					this.Close();
//					return;
//				}
				this.Size = this.MinimumSize;
				pnlFinished.Visible = true;
				pnlFinished.Top = pgbTotal.Top;
				pnlFinished.Left = 0;
				pnlFinished.Width = this.Width;
				pnlFinished.Height = this.Height - 70;
			}
		}

		private void UpdateListItemStatus(int itemIndex, string newStatus) {
			if (InvokeRequired) {
				BeginInvoke(new UpdateListItemStatusDelegate(this.UpdateListItemStatus), new object[] {itemIndex, newStatus});
			} else {
				lvwMain.Items[itemIndex].SubItems[1].Text = newStatus;
			}
		}

		private void UpdateProgress(int percentDone) {
			if (InvokeRequired) {
				BeginInvoke(new UpdateProgressDelegate(this.UpdateProgress), new object[] {percentDone});
			} else {
				pgbTotal.Value = percentDone;
			}
		}

		private void InitiateDragDrop() {
			DragDropFile ddf = new DragDropFile(tempFiles);
			this.DoDragDrop(ddf, DragDropEffects.Move);
		}

		private void cmdDrag_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			InitiateDragDrop();
		}

		private void cmdCloseAndDeleteFiles_Click(object sender, System.EventArgs e) {
			DeleteTempFiles();
			this.Close();
		}

		private void DeleteTempFiles() {
			if (tempFiles == null) { return; }
			for(int i = 0; i < ObjectsToCopy.Count; i++) {
				if (tempFiles[i] == null) continue; // If the temp file was not created for some reason.
				RFSObject o = (RFSObject)ObjectsToCopy[i];
				try {
					if (o.ObjectType == RFSObjectType.File && File.Exists(tempFiles[i])) {
						File.Delete(tempFiles[i]);
					} else if (Directory.Exists(tempFiles[i])) {
						Directory.Delete(tempFiles[i], true);
					}
				}
				catch (Exception ex) {
					MessageBox.Show(ex.ToString());
				}
			}
		}

		private void frmCopy_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
			DeleteTempFiles();
		}

		private void cmdHideFinishedPanel_Click(object sender, System.EventArgs e) {
			if (pnlFinished.Visible) { pnlFinished.Hide(); } else { pnlFinished.Show(); }
		}
	}
}
