using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace RFSExplorer {
	/// <summary>
	/// Summary description for frmProperties.
	/// </summary>
	public class frmProperties : System.Windows.Forms.Form {

		private RFSObject rfsObject = null;
		private int startingHeight;
		private WinFormUtils winFormUtils = new WinFormUtils();

		#region Controls
		private System.Windows.Forms.Label lblHeading;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblName;
		private System.Windows.Forms.Label lblAbsolutePath;
		private System.Windows.Forms.Button cmdOk;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label lblSize;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label lblPerm_Owner;
		private System.Windows.Forms.Label lblPerm_Group;
		private System.Windows.Forms.Label lblPerm_Other;
		private System.Windows.Forms.Label lblSpecialBit;
		private System.Windows.Forms.Label label;
		#endregion

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmProperties(RFSObject rfsObject) {
			if (rfsObject == null) {
				throw new NullReferenceException("rfsObject cannot be null!");
			}
			this.rfsObject = rfsObject;

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			startingHeight = this.Height;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if(components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.lblHeading = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.lblName = new System.Windows.Forms.Label();
			this.lblAbsolutePath = new System.Windows.Forms.Label();
			this.cmdOk = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.lblPerm_Owner = new System.Windows.Forms.Label();
			this.lblPerm_Group = new System.Windows.Forms.Label();
			this.lblPerm_Other = new System.Windows.Forms.Label();
			this.lblSize = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.lblSpecialBit = new System.Windows.Forms.Label();
			this.label = new System.Windows.Forms.Label();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblHeading
			// 
			this.lblHeading.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this.lblHeading.AutoSize = true;
			this.lblHeading.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblHeading.Location = new System.Drawing.Point(96, 8);
			this.lblHeading.Name = "lblHeading";
			this.lblHeading.TabIndex = 1;
			this.lblHeading.Text = "Properties";
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(8, 48);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(34, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Name";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(8, 72);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(75, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "Absolute Path";
			// 
			// lblName
			// 
			this.lblName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblName.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblName.Location = new System.Drawing.Point(88, 48);
			this.lblName.Name = "lblName";
			this.lblName.Size = new System.Drawing.Size(192, 16);
			this.lblName.TabIndex = 2;
			this.lblName.Paint += new System.Windows.Forms.PaintEventHandler(this.lblName_Paint);
			// 
			// lblAbsolutePath
			// 
			this.lblAbsolutePath.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblAbsolutePath.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblAbsolutePath.Location = new System.Drawing.Point(88, 72);
			this.lblAbsolutePath.Name = "lblAbsolutePath";
			this.lblAbsolutePath.Size = new System.Drawing.Size(192, 16);
			this.lblAbsolutePath.TabIndex = 2;
			this.lblAbsolutePath.Paint += new System.Windows.Forms.PaintEventHandler(this.lblAbsolutePath_Paint);
			// 
			// cmdOk
			// 
			this.cmdOk.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.cmdOk.Location = new System.Drawing.Point(205, 250);
			this.cmdOk.Name = "cmdOk";
			this.cmdOk.TabIndex = 3;
			this.cmdOk.Text = "&Ok";
			this.cmdOk.Click += new System.EventHandler(this.cmdOk_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.label5);
			this.groupBox2.Controls.Add(this.label6);
			this.groupBox2.Controls.Add(this.lblPerm_Owner);
			this.groupBox2.Controls.Add(this.lblPerm_Group);
			this.groupBox2.Controls.Add(this.lblPerm_Other);
			this.groupBox2.Location = new System.Drawing.Point(88, 144);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(128, 96);
			this.groupBox2.TabIndex = 5;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Permissions";
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.Location = new System.Drawing.Point(8, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(38, 16);
			this.label3.TabIndex = 0;
			this.label3.Text = "Owner";
			// 
			// label5
			// 
			this.label5.AutoSize = true;
			this.label5.Location = new System.Drawing.Point(8, 48);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(36, 16);
			this.label5.TabIndex = 0;
			this.label5.Text = "Group";
			// 
			// label6
			// 
			this.label6.AutoSize = true;
			this.label6.Location = new System.Drawing.Point(8, 72);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(32, 16);
			this.label6.TabIndex = 0;
			this.label6.Text = "Other";
			// 
			// lblPerm_Owner
			// 
			this.lblPerm_Owner.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblPerm_Owner.Location = new System.Drawing.Point(64, 24);
			this.lblPerm_Owner.Name = "lblPerm_Owner";
			this.lblPerm_Owner.Size = new System.Drawing.Size(48, 16);
			this.lblPerm_Owner.TabIndex = 2;
			this.lblPerm_Owner.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblPerm_Group
			// 
			this.lblPerm_Group.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblPerm_Group.Location = new System.Drawing.Point(64, 48);
			this.lblPerm_Group.Name = "lblPerm_Group";
			this.lblPerm_Group.Size = new System.Drawing.Size(48, 16);
			this.lblPerm_Group.TabIndex = 2;
			this.lblPerm_Group.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblPerm_Other
			// 
			this.lblPerm_Other.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblPerm_Other.Location = new System.Drawing.Point(64, 72);
			this.lblPerm_Other.Name = "lblPerm_Other";
			this.lblPerm_Other.Size = new System.Drawing.Size(48, 16);
			this.lblPerm_Other.TabIndex = 2;
			this.lblPerm_Other.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblSize
			// 
			this.lblSize.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblSize.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblSize.Location = new System.Drawing.Point(88, 96);
			this.lblSize.Name = "lblSize";
			this.lblSize.Size = new System.Drawing.Size(192, 16);
			this.lblSize.TabIndex = 2;
			// 
			// label4
			// 
			this.label4.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label4.AutoSize = true;
			this.label4.Location = new System.Drawing.Point(8, 96);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(26, 16);
			this.label4.TabIndex = 2;
			this.label4.Text = "Size";
			// 
			// lblSpecialBit
			// 
			this.lblSpecialBit.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblSpecialBit.Location = new System.Drawing.Point(88, 120);
			this.lblSpecialBit.Name = "lblSpecialBit";
			this.lblSpecialBit.Size = new System.Drawing.Size(16, 16);
			this.lblSpecialBit.TabIndex = 2;
			this.lblSpecialBit.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label
			// 
			this.label.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label.AutoSize = true;
			this.label.Location = new System.Drawing.Point(8, 120);
			this.label.Name = "label";
			this.label.Size = new System.Drawing.Size(58, 16);
			this.label.TabIndex = 2;
			this.label.Text = "Special Bit";
			// 
			// frmProperties
			// 
			this.AcceptButton = this.cmdOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 302);
			this.ControlBox = false;
			this.Controls.Add(this.cmdOk);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lblHeading);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label);
			this.Controls.Add(this.lblName);
			this.Controls.Add(this.lblAbsolutePath);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.lblSize);
			this.Controls.Add(this.lblSpecialBit);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(300, 310);
			this.Name = "frmProperties";
			this.ShowInTaskbar = false;
			this.Text = "Properties";
			this.Resize += new System.EventHandler(this.frmProperties_Resize);
			this.Load += new System.EventHandler(this.frmProperties_Load);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void frmProperties_Load(object sender, System.EventArgs e) {
			lblName.Text = rfsObject.Name;
			lblAbsolutePath.Text = rfsObject.AbsolutePath;
			lblSpecialBit.Text = rfsObject.Permissions.Substring(0,1);
			lblPerm_Owner.Text = rfsObject.Permissions.Substring(1,3);
			lblPerm_Group.Text = rfsObject.Permissions.Substring(4,3);
			lblPerm_Other.Text = rfsObject.Permissions.Substring(7,3);

			if (rfsObject.ObjectType == RFSObjectType.File) {
				lblSize.Text = rfsObject.Size.ToString();
			}
		}

		private void cmdOk_Click(object sender, System.EventArgs e) {
			this.Close();
		}

		private void frmProperties_Resize(object sender, System.EventArgs e) {
			this.Height = startingHeight;
		}

		private void lblAbsolutePath_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
			winFormUtils.MakePathElliptical_OnPaint(lblAbsolutePath, e.Graphics);
		}

		private void lblName_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
			winFormUtils.MakePathElliptical_OnPaint(lblName, e.Graphics);
		}
	}
}
